package com.connor.bhdz.pdm.partToCapp;

import java.awt.Frame;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.connor.bhdz.pdm.assets.Constants;
import com.connor.bhdz.pdm.drawingToCapp.ConnOra;
import com.connor.bhdz.pdm.drawingToCapp.ProgressBarThread;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.common.actions.AbstractAIFAction;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpException;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;

public class SendPartToCappAction extends AbstractAIFAction {
	private AbstractAIFApplication application;
	private TCSession session;

	protected SendPartToCappAction(AbstractAIFApplication application, Frame frame, String param) {
		super(application, frame, param);
		this.application = application;
		this.session = (TCSession) application.getSession();
	}
	
	/**
	 * ȡǰʱ䣬ʽΪ"yyyy-MM-dd HH-mm-ss"
	 * @return String
	 */
	private String getCurrentTime() {
		System.out.println("getCurrentTimeʼִ");
		// ȡǰʱ
        LocalDateTime now = LocalDateTime.now();
 
        // Զʱʽ
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH-mm-ss");
 
        // ʽǰʱ
        String formattedDate = now.format(formatter);
 
		return formattedDate;
		
	}
	
	
	/**
	 * BOMУ֯BOMԴ洢ݿBOM	
	 * @param bomLine bom
	 * @throws TCException 
	 * @throws SQLException 
	 */
//	private void throwBom(TCComponentBOMLine bomLine) throws TCException, SQLException {
//		// TODO Auto-generated method stub
//		//ȡBOMϢ
//		TCComponentItem item = bomLine.getItem();
//		TCComponentItemRevision itemRevision = bomLine.getItemRevision();
//		String parent = item.getProperty("item_id");//ͼ
//		String parentversion = itemRevision.getProperty("item_revision_id");//ϰ汾
//		String parentname = item.getProperty("object_name");//
//		
//		//BOMȡϢ
//		if (bomLine.hasChildren()) {
//			AIFComponentContext[] childrens = bomLine.getChildren();
//			for (AIFComponentContext children : childrens) {
//				TCComponentBOMLine bomLineChild = (TCComponentBOMLine) children.getComponent();
//				TCComponentItem childItem = bomLineChild.getItem();
//				TCComponentItemRevision childItemRevision = bomLineChild.getItemRevision();
//				//Ϣݿ
////				savePart(childItemRevision);
//				//֯Ϣ͸Ϣһ𱣴Ϊһ
//				String sub = childItem.getProperty("item_id");//ϱ
//				String subversion = childItemRevision.getProperty("item_revision_id");//汾
//				String subname = childItem.getProperty("object_name");//
//				bomLineChild.lock();
//				String lineno = bomLineChild.getProperty("bl_sequence_no");//к
//				String quantity = bomLineChild.getProperty("bl_quantity");//
//				bomLineChild.unlock();
//				String user = session.getUser().getUserName();//·Ա
//				//TODO ݸ汾IDȷΨһԣѯǷѾڸBOMݣѴֻ桱ʱ䡱Ϊǰʱ䣻򱣴桰·ʱ䡱͡ʱ䡱Ϊǰʱ䣩
//				if (true/**/) {
//					String issuedtime = getCurrentTime();
//					String updatetime = getCurrentTime();
//					//TODO ݵBOMݿ
//					
//				}else {
//					String updatetime = getCurrentTime();
//					//TODO ݵBOMݿ
//					
//				}
//				throwBom(bomLineChild);
//			}
//		}
//	}

	public static boolean isReleased(TCComponent comp) throws Exception {
		TCComponent[] status = comp.getReferenceListProperty("release_status_list");
		if (status == null || status.length == 0) {
			return false;
		}
		return true;
	}
	public static TCComponentItemRevision getLastReleaseRevison(TCComponentItem targetComp) throws Exception {
		System.out.println("Get Last Released Revision: " + targetComp);
		if (targetComp == null) {
			return null;
		}
		List<TCComponentItemRevision> releaseRevisionList = new ArrayList<>();
		TCComponent[] comps = targetComp.getReferenceListProperty("revision_list");
		System.out.println(">> Revisions: " + Arrays.toString(comps));
		for (TCComponent comp : comps) {
			if (isReleased(comp)) {
				releaseRevisionList.add((TCComponentItemRevision) comp);
			}
		}
		System.out.println(">> Released Revisions: " + releaseRevisionList);
		return releaseRevisionList.size() == 0 ? null : releaseRevisionList.get(releaseRevisionList.size() - 1);
	}

	

	@Override
	public void run() {
		ProgressBarThread thread = new ProgressBarThread("·", "·..."); 
		thread.start(); 
		
		InterfaceAIFComponent[] components = application.getTargetComponents();
		try {
			for (InterfaceAIFComponent selectComponent : components) {
				String itemID = "";//ID
				String revID = "";//汾
				String sql = "";
				String toTaskRevId = "";//msg
				if (selectComponent instanceof TCComponentItem) {
					//ѡж϶H8_wuliao
					TCComponentItem item = (TCComponentItem) selectComponent;
					//ȡѷ汾-latestReleasedRev
					TCComponentItemRevision latestItemRevision = getLastReleaseRevison(item);
					if (latestItemRevision == null) {
						System.out.println("ǰѡж󲻴ѷ汾޷·");
						MessageBox.post("ǰѡж󲻴ѷ汾޷·","ʾ",MessageBox.INFORMATION);
						thread.setBool(true);
						return;
					}
					revID = latestItemRevision.getProperty("item_revision_id");//Cеòѯݣȡ汾
					itemID = latestItemRevision.getProperty("item_id");
					toTaskRevId = itemID + "-" + revID;
						
				}else if (selectComponent instanceof TCComponentItemRevision) {
					//TODO ѡжϰ汾H8_PartRevision
					System.out.println("ǰѡж H8_drawingRevision");
					TCComponentItemRevision revision = (TCComponentItemRevision)selectComponent;
					String releaseDate = revision.getProperty("date_released");
					System.out.println("===>ȡǰ汾ķ״̬"+releaseDate);
					if (releaseDate == null) {
						System.out.println("ǰ汾δ");
						MessageBox.post("ǰ汾δ޷·","ʾ",MessageBox.INFORMATION);
						thread.setBool(true);
						return;
					}
					revID = revision.getProperty("item_revision_id");
					itemID = revision.getProperty("item_id");
					toTaskRevId = itemID + "-" + revID;
					
				}else {
					MessageBox.post("erro select!","tip",MessageBox.INFORMATION);
					return;
					
				}
				//֯msgTask
				String tasksource = "ֶ·";
				String userName = session.getUser().getUserName();
				String userId = session.getUser().getUserId();
				String status = "δʼ";
				String starttime = getCurrentTime();
				//жtaskǷѾͬ
				
				Map<String, Object> paramMap = new HashMap<String, Object>();
				//ƥspringbootеĲѯ
				paramMap.put("MSG", toTaskRevId);
				Integer result = sendRequest("getByMSG",paramMap);
				if (result > 0) {//ظݣ
					System.out.println("TASKظݣ¡");
					Map<String, Object> paramMapU = new HashMap<String, Object>();
					paramMapU.put("TASKSOURCE",tasksource);
					paramMapU.put("USERNAME",userName);
					paramMapU.put("USERID",userId);
					paramMapU.put("STATUS",status);
					paramMapU.put("STARTTIME",starttime);
					paramMapU.put("MSG",toTaskRevId);
					Integer resultU = sendRequest("updateTask",paramMapU);
					if (resultU == -1){
						System.out.println("springbootʧܣupdateTask");
					}
				}else {//ظݣ
					System.out.println("TASKظݣ롤");
					Map<String, Object> paramMapI = new HashMap<String, Object>();
					paramMapI.put("TASKSOURCE",tasksource);
					paramMapI.put("USERNAME",userName);
					paramMapI.put("USERID",userId);
					paramMapI.put("STATUS",status);
					paramMapI.put("MSG",toTaskRevId);
					paramMapI.put("STARTTIME",starttime);
					Integer resultI = sendRequest("insertTask",paramMapI);
					if (resultI == -1){
						System.out.println("springbootʧܣinsertTask");
					}
					System.out.println("1");
				}
				System.out.println("2");
			}
			System.out.println("deal end!");
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println("===>·ʧ");
			MessageBox.post("·ʧ","ʾ",MessageBox.INFORMATION);
			e.printStackTrace();
		}
		MessageBox.post("·ɹ","ʾ",MessageBox.INFORMATION);
		
		thread.setBool(true);
	}
	
	/**
	 * 첽
	 * @return -1 ʾʧ
	 */
	private Integer sendRequest(String way,Map<String, Object> param){
		System.out.println("ʼ÷SpringBoot󡤡");
		Integer resultInteger = 0;
		String urlString = "http://"+Constants.SPRING_ADDRESS+"/part/"+way;
        try {//Իip192.168.3.125
            String url = StrUtil.format(urlString);//springbootڷipַ
            System.out.println(urlString);
         // POST
            HttpResponse response = HttpRequest.post(url)
                    .header("Content-Type", "application/json") // ΪJSON
                    .body(JSONUtil.toJsonStr(param)) // ΪJSONַ
					.timeout(20*1000) // óʱʱ
					.execute();
            System.out.println("SpringBootִݿĽΪ"+response.body()+"\n ЯϢΪ"+param.toString());
            resultInteger = Integer.parseInt(response.body());
            int statusCode = response.getStatus();
            if (statusCode < 200 && statusCode > 300) {
                System.out.println("Ӧ쳣: ȡϢΪ!");
                return -1;
            }

        } catch (HttpException e) {
			// Ƿǳʱ쳣
			if (e.getMessage().contains("Read timed out") || e.getMessage().contains("Connect timed out")) {
				System.out.println("ʱ: " + e.getMessage());
				return -2; // ʹòͬķֵʶʱ
			} else {
				// ͵HttpException
				System.out.println("зHttpException: " + e.getMessage());
				return -1;
			}
		} catch (Exception e) {
			// 쳣
			System.out.println("з쳣: " + e.getMessage());
			e.printStackTrace(); // ӡջϢԱ
			return -1;
		}

        return resultInteger;
	}

}
